import builtins

# List of modules which do not to have to be imported
BUILTIN_TYPES = ["None", "NoneType"] + [
    k for k, v in builtins.__dict__.items() if isinstance(v, type)
]

## HARD CODED
# List of modules and their corresponding parent modules
MODULES = {
    "_io": None,
    "Boost.Python": None,
    "sqlalchemy": None,
    "urllib": None,
    "enum": None,
    "ModuleType": "typing",
    "Annotated": "typing",
    "Any": "typing",
    "Callable": "typing",
    "overload": "typing",
    "_Alias": "typing",
    "moves": "_dummyPackage",
    # "DistFunctions": "rdkit.ML.KNN",
    # "ID3Boot": "rdkit.ML.DecTree",
    "FilterMatcherBase": "rdkit.Chem.rdfiltercatalog",
    "QCanvasText": "_dummyQt",
    "QWidget": "_dummyQt",
    "Mol": "rdkit.Chem.rdchem",
    "Conformer": "rdkit.Chem.rdchem",
    "QueryBond": "rdkit.Chem.rdchem",
    "QueryAtom": "rdkit.Chem.rdchem",
    "SubstructMatchParameters": "rdkit.Chem.rdchem",
    "MolBundle": "rdkit.Chem.rdchem",
    "StereoGroupType": "rdkit.Chem.rdchem",
    "AtomPairsParameters": "rdkit.Chem.rdMolDescriptors",
    "Point2D": "rdkit.Geometry.rdGeometry",
    "Point3D": "rdkit.Geometry.rdGeometry",
    "UniformGrid3D_": "rdkit.Geometry.rdGeometry",
    "ExplicitBitVect": "rdkit.DataStructs.cDataStructs",
    "SparseBitVect": "rdkit.DataStructs.cDataStructs",
    "UIntSparseIntVect": "rdkit.DataStructs.cDataStructs",
    "ULongSparseIntVect": "rdkit.DataStructs.cDataStructs",
    "LongSparseIntVect": "rdkit.DataStructs.cDataStructs",
    "IntSparseIntVect": "rdkit.DataStructs.cDataStructs",
    "DiscreteValueType": "rdkit.DataStructs.cDataStructs",
    "DiscreteValueVect": "rdkit.DataStructs.cDataStructs",
    "_vecti": "rdkit.rdBase",
    "_vectj": "rdkit.rdBase",
    "_vectd": "rdkit.rdBase",
    "Atom": "rdkit.Chem.rdchem",
    "Bond": "rdkit.Chem.rdchem",
    "Color": "rdkit.sping.colors",
    "Font": "rdkit.sping.pid",
    "InfoType": "rdkit.ML.InfoTheory.rdInfoTheory",
    "ChemicalReaction": "rdkit.Chem.rdChemReactions",
    "VectSizeT": "rdkit.Chem.rdChemReactions",
    "ForceField": "rdkit.ForceField.rdForceField",
    "MMFFMolProperties": "rdkit.ForceField.rdForceField",
    "_vectNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEE": "rdkit.rdBase",
    "_vectSt6vectorIjSaIjEE": "rdkit.rdBase",
    "_listSt6vectorIiSaIiEE": "rdkit.rdBase",
    "_vectSt6vectorIiSaIiEE": "rdkit.rdBase",
    "_vectN5RDKit9Chirality10StereoInfoE": "rdkit.Chem.rdmolops",
    "_ROBondSeq": "rdkit.Chem.rdchem",
    "_ROAtomSeq": "rdkit.Chem.rdchem",
    "_ROQAtomSeq": "rdkit.Chem.rdchem",
    "_ROConformerSeq": "rdkit.Chem.rdchem",
    "_vectN5RDKit13Abbreviations22AbbreviationDefinitionE": "rdkit.Chem.rdAbbreviations",
    "AdjustQueryParameters": "rdkit.Chem.rdmolops",
}
